(function ($) {
    "use strict";
    /* 
    *	Author: M Hemel Hasan
    *   @since 3.2
    *   Description: chcek Cross Sell Emty or not And Updated Cart
    */
    document.addEventListener('DOMContentLoaded', function () {

        // updeted Cart
        setTimeout(function () {
            $('.ins-checkout-layout button[name="update_cart"]').trigger("click");
        }, 1000);

        // Get the element with the class .ins-card-cross-sell
        var crossSellDiv = document.querySelector('.ins-card-cross-sell .ins-cross-sells');

        // Check if the div has content (child nodes)
        if (crossSellDiv !== null && crossSellDiv.hasChildNodes()) {
            // The div has content
            $('.ins-cart-inner.payment .ins-card-cross-sell').addClass('active');
        } else {
            // The div is empty
            $('.ins-cart-inner.payment .ins-card-cross-sell').removeClass('active');
        }
    });

    // Owl Carousel Up Sell
    $(document).ready(function ($) {
        $('.ins-product-sell-carousel').owlCarousel({
            // loop:true,
            responsiveClass: true,
            margin: 10,
            responsive: {
                0: {
                    items: 1
                },
                600: {
                    items: 2
                },
                1000: {
                    items: 2
                }
            }
        })
    });

    $(document).ready(function () {

        // Instantio Multistep Checkout
        $(document).on("click", ".ins-single-step.done, .ins-btns-step-next, .ins-back-to-edit", function (e) {
            e.preventDefault();

            var step = $(this).data('step-content');
            var prev = $(this).data('step-prev');

            insStepNext(step, prev);

            // redirect after login into same Page 
            if ($('.ins-login-form').find('input[name="redirect"]').length > 0) {
                var currentUrl = window.location.href;
                $('.ins-login-form').find('input[name="redirect"]').val(currentUrl);

            }

        });

        // Instantio Multistep Checkout
        $(document).on("click", ".ins-mobie-bar_icon", function (e) {
            // alert(1);
            e.preventDefault();
            $(".ins-click-to-show").trigger("click");
        });

        // Instantio Mobile Checkout
        $(document).on("click", ".ins-mobile-checkout", function (e) {
            e.preventDefault();
            // if (!$('.ins-checkout-popup').hasClass('active')) {
            // 	$(".ins-click-to-show").addClass("active");
            // }
            // $(".ins-click-to-show").trigger("click");
            $(".ins-checkout-popup").toggleClass("active");
            $(".ins-checkout-layout").toggleClass("active");
            $(".ins-checkout-overlay").toggleClass("active");

        });

        // Shopping Cart Checkout
        $(document).on("keyup", ".ins-cart-inner.shipping input", function (e) {
            var value = $(this).val();
            var name = this.name;
            $('#' + name + '_field').removeClass('ins-invalid-required');
            $('#' + name + '_field .ins-error-message').remove();
            if (value != '') {
                $(this).closest('p.form-row').find('label').addClass('active');
            } else {
                $(this).closest('p.form-row').find('label').removeClass('active');
            }
        });

        // Shopping Cart Checkout With Validation
        $(document).on("click", "#ins-shipping-button", function (e) {
            e.preventDefault();

            var $this = $(this);
            $(".loader-container").addClass("active");
            $('body').trigger('update_checkout');

            setTimeout(function () {
                var errors = 0;
                var fields = {};
                $(".loader-container").removeClass("active");
                $('.ins-cart-inner.shipping .woocommerce-billing-fields').find('input, select, textarea').each(function () {
                    var name = this.name;
                    if (fields[name]) {
                        fields[name] = '';
                    }
                    if ($(this).attr('type') == 'checkbox' || $(this).attr('type') == 'radio') {
                        if ($(this).is(':checked')) {
                            fields[name] = true;
                        }
                    } else {
                        fields[name] = $(this).val();
                    }
                    $('#' + name + '_field').removeClass('ins-invalid-required');
                    $('#' + name + '_field .ins-error-message').remove();
                    if ($('#' + name + '_field').hasClass('validate-required')) {
                        if ($(this).val() == '') {
                            var label = $('#' + name + '_field label').text().trim();
                            label = label.replace('*', '');
                            errors += 1;
                            $('#' + name + '_field').addClass('ins-invalid-required');
                            $('#' + name + '_field').append('<span class="ins-error-message">' + label + ' is required</span>');
                        } else {
                            $('#' + name + '_field').removeClass('ins-invalid-required');
                        }
                    }
                });
                if ($('#ship-to-different-address-checkbox').is(':checked')) {
                    $('.ins-cart-inner.shipping .woocommerce-shipping-fields').find('input, select, textarea').each(function () {
                        var name = this.name;
                        if (fields[name]) {
                            fields[name] = '';
                        }
                        if ($(this).attr('type') == 'checkbox' || $(this).attr('type') == 'radio') {
                            if ($(this).is(':checked')) {
                                fields[name] = true;
                            }
                        } else {
                            fields[name] = $(this).val();
                        }
                        $('#' + name + '_field').removeClass('ins-invalid-required');
                        $('#' + name + '_field .ins-error-message').remove();
                        if ($('#' + name + '_field').hasClass('validate-required')) {
                            if ($(this).val() == '') {
                                var label = $('#' + name + '_field label').text().trim();
                                label = label.replace('*', '');
                                errors += 1;
                                $('#' + name + '_field').addClass('ins-invalid-required');
                                $('#' + name + '_field').append('<span class="ins-error-message">' + label + ' is required</span>');
                            } else {
                                $('#' + name + '_field').removeClass('ins-invalid-required');
                            }
                        }
                    });
                }

                if (errors == 0) {
                    $.ajax({
                        url: ins_params_pro.ajax_url,
                        type: "POST",
                        // contentType: 'application/json',
                        data: {
                            id: "1",
                            fields: JSON.stringify(fields),
                            action: "ins_update_order_review_callback",
                        },
                        beforeSend: function (response) {
                        },
                        complete: function (response) {

                        },
                        success: function (response) {
                            var step = $this.data('step-content');
                            var prev = $this.data('step-prev');
                            // $('.ins-cart-inner.payment').html('');
                            // $('.ins-cart-inner.payment').append(response.data);
                            $('.ins-cart-inner.payment .ins-contact-wrap').html('');
                            $('.ins-cart-inner.payment .ins-contact-wrap').append(response.data.ins_contact);
                            $('.ins-cart-inner.payment .ins-shipping-wrap').html('');
                            $('.ins-cart-inner.payment .ins-shipping-wrap').append(response.data.ins_shiiping);
                            $('.ins-cart-inner.payment .ins-delivery-wrap.shipping').html('');
                            $('.ins-cart-inner.payment .ins-delivery-wrap.shipping').append(response.data.ins_shipping_details);
                            //  $('.ins-cart-inner.payment .form-row.place-order').remove();
                            $('.ins-cart-inner.payment .form-row.place-order').hide();
                            $('.ins-cart-inner.payment .ins-review-order-table').html('');
                            $('.ins-cart-inner.payment .ins-review-order-table').append(response.data.ins_order_summery);
                            $('.ins-cart-inner.payment .ins-order-summery-subtotal').html('');
                            $('.ins-cart-inner.payment .ins-order-summery-subtotal').append(response.data.ins_order_total);
                            $('.ins-cart-inner.payment .ins-card-cross-sell').html('');
                            $('.ins-cart-inner.payment .ins-card-cross-sell').append(response.data.cross_sells);

                            if (response.data.cross_sells != '' && response.data.cross_sells != null) {
                                $('.ins-cart-inner.payment .ins-card-cross-sell').addClass('active');
                            } else {
                                $('.ins-cart-inner.payment .ins-card-cross-sell').removeClass('active');
                            }

                            if (!$('.ins-cart-inner.payment').hasClass('active')) {
                                insStepNext(step, prev)
                            }

                            $('body').trigger('update_checkout');
                            ins_owl_carousel();

                        },
                    });
                }
            }, 1000);
        });

        // Payment Method Change
        $(document).on("click", '.ins-delivery-wrap.shipping input', function (e) {
            $('#ins-shipping-button').trigger('click');
        });

        // Payment Method Change
        $(document).on("click", '.ins-showlogin', function (e) {
            $(".ins-login-form").slideToggle();
            $(".ins-login-form").toggleClass('active');
        });

        // Payment Method Change
        $(document).on("change", '.ins-payment-method li input[type="radio"]', function (e) {
            $('.ins-payment-method li > div').slideUp().removeClass('active');
            if ($(this).is(':checked')) {
                $(this).closest('li').find(' > div').slideDown().addClass('active');
            }
        });


        // Payment Method Change
        $(document).on("click", '.ins-delivery-wrap.shipping input', function (e) {
            $('#ins-shipping-button').trigger('click');
        });

        // Payment Method Change
        $(document).on("click", '.ins-cart-inner.payment .wc_payment_method label', function (e) {
            var payment_type = $(this).parent().find('input').attr('value');
            if (payment_type == 'ppcp-gateway') {
                $('.ins-cart-inner.payment .ins-cart-btns').hide();
            } else {
                $('.ins-cart-inner.payment .ins-cart-btns').show();
            }
        });

        // instantio multi step next Function
        function insStepNext(step, prev) {
            $(".loader-container").addClass("active");

            setTimeout(function () {
                $(".loader-container").removeClass("active");
                $('.ins-single-step.' + step).removeClass('done');
                $('.ins-single-step').removeClass('active');
                // $('.ins-single-step[data-step-content = '+prev+']').addClass('done'); 
                $('.ins-single-step.' + step).prevAll().addClass('done');
                $('.ins-single-step.' + step).nextAll().removeClass('done');
                $(".ins-cart-inner").removeClass("active");
                $('.ins-content').find('.' + step).addClass('active');
                $('.ins-single-step.' + step).addClass('active');
                $('.ins-content').find('.ins-cart-inner').hide();
                $('.ins-content').find('.' + step).show();

                $('.ins-cart-inner.shipping input').each(function () {
                    var value = $(this).val();
                    if (value != '') {
                        $(this).closest('p.form-row').find('label').addClass('active');
                    } else {
                        $(this).closest('p.form-row').find('label').removeClass('active');
                    }
                });
                ins_cart_animation(step);

                if (step == 'step-1') {
                    $('.ins-content .woocommerce-checkout').hide();
                } else {
                    $('.ins-content .woocommerce-checkout').show();
                }
            }, 1000);
        }

        // Instantio Owl Carlusel Function
        function ins_owl_carousel() {
            $('.ins-product-sell-carousel').owlCarousel('destroy');
            $('.ins-product-sell-carousel').owlCarousel({
                // loop:true,
                margin: 10,
                responsiveClass: true,
                responsive: {
                    0: {
                        items: 1
                    },
                    600: {
                        items: 2
                    },
                    1000: {
                        items: 2
                    }
                }
            });
        }

        // Cart Animation Gsap
        function ins_cart_animation(step = '') {
            if ($('.ins_animate_one').length > 0) {
                if (step == 'shipping') {
                    gsap.from(".ins_animate_one .shipping .ins-checkout-billing", { opacity: 0, y: -100, duration: 0.2, delay: 0.2, ease: "fadeIn" });
                    gsap.from(".ins_animate_one .shipping .ins-checkout-shipping", { opacity: 0, y: -100, duration: 0.2, delay: 0.4, ease: "fadeIn" });
                }

                if (step == 'step-1') {
                    gsap.from(".ins_animate_one .step-1 .ins-cart-content-wrap, .ins_animate_one .step-1 .ins-up-sells", { opacity: 0, y: -100, duration: 0.2, delay: 0.4, ease: "fadeIn" });
                    gsap.from(".ins_animate_one .step-1 .ins-cart-footer-content, .ins_animate_one .step-1  .ins-cart-btns", { opacity: 0, x: 100, duration: 0.2, delay: 0.6, ease: "fadeIn" });
                }
                if (step == 'payment') {
                    gsap.from(".ins_animate_one .payment .ins-payment-left", { opacity: 0, y: -100, duration: 0.2, delay: 0.2, ease: "fadeIn" });
                    gsap.from(".ins_animate_one .payment .ins-payment-center", { opacity: 0, y: -100, duration: 0.2, delay: 0.35, ease: "fadeIn" });
                    gsap.from(".ins_animate_one .payment .ins-payment-right, .ins_animate_one .slide .payment .ins_animate_one .ins-cross-sells, .ins_animate_one .slide .payment .Ins-terms", { opacity: 0, y: -100, duration: 0.2, delay: 0.5, ease: "fadeIn" });
                }
            }
            // alert(step);
        }


    });


})(jQuery);
