<?php  
namespace INS_PRO\Controller;

class Assets {
    public function __construct() { 
        add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_custom_js_scripts_pro' ), 99999 ); 
        add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_custom_css_scripts_pro' ), 99999 ); 
        add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_scripts' ), 10 ); 
        add_action( 'admin_enqueue_scripts', array( $this, 'admin_enqueue_scripts'), 10 );

        add_filter( 'ins_style_min_status_checked', array($this, 'ins_style_min_status_checked'), );
        add_filter( 'ins_script_min_status_checked', array($this, 'ins_script_min_status_checked'), ); 
    } 


    // enqueue custom js scripts
    public function enqueue_scripts() { 
        $css_min = insopt('css-min');

        if(isset($css_min) && $css_min == true){
            wp_enqueue_style( 'ins-style-pro', INS_PRO_ASSETS_URL.'/app/css/instantio-style-pro.min.css', array(), INSTANTIO_PRO_VERSION ); 
        } else {
            wp_enqueue_style( 'ins-style-pro', INS_PRO_ASSETS_URL.'/app/css/instantio-style-pro.css', array(), INSTANTIO_PRO_VERSION ); 
        }
        
        wp_enqueue_style( 'ins-owl-carousel', INS_PRO_ASSETS_URL.'/app/css/owl.carousel.min.css', array(), INSTANTIO_PRO_VERSION ); 

        if( class_exists( 'woocommerce' ) ) { 
			wp_enqueue_script( 'wc-checkout' ); 
            wp_enqueue_style('select2');
            wp_enqueue_script('select2');
            wp_dequeue_script( 'selectWoo' );
            wp_enqueue_script( 'wc-country-select' ); 
		}

        wp_enqueue_script( 'ins-owl-carousel-js', INS_PRO_ASSETS_URL.'/app/js/owl.carousel.min.js', array('jquery'), INSTANTIO_PRO_VERSION, true );
        
        $js_min = insopt('js-min');
        if(isset($js_min) && $js_min == true){ 
             wp_enqueue_script( 'ins-script-pro', INS_PRO_ASSETS_URL.'/app/js/instantio-script-pro.min.js', array('jquery'), INSTANTIO_PRO_VERSION, true ); 
        } else { 
            wp_enqueue_script( 'ins-script-pro', INS_PRO_ASSETS_URL.'/app/js/instantio-script-pro.js', array('jquery'), INSTANTIO_PRO_VERSION, true ); 
        }

        wp_localize_script( 'ins-script-pro', 'ins_params_pro',
            array( 
                'ajax_url' => admin_url( 'admin-ajax.php' ),
            )
        ); 
   
    }

    // enqueue custom js scripts
    public function admin_enqueue_scripts() { 
        wp_enqueue_style( 'ins-admin', INS_PRO_ASSETS_URL.'/admin/css/instantio-admin-style.css', array(), INSTANTIO_PRO_VERSION ); 
        wp_enqueue_script( 'ins-admin-script', INS_PRO_ASSETS_URL.'/admin/js/instantio-admin-script.js', array('jquery'), INSTANTIO_PRO_VERSION, true );
         
        wp_localize_script( 'ins-admin-script', 'tf_admin_params', array( 
			'ajax_url'                   => admin_url( 'admin-ajax.php' ),
            'ins_nonce'                  => wp_create_nonce('updates'),
            'ins_ajax_nonce'             => wp_create_nonce( 'ins_ajax_nonce' ),
		) );
    }

    // Checked ins minified css status
    public function ins_style_min_status_checked($style){
        $css_min = insopt('css-min');
        if(isset($css_min) && $css_min == true){
            $style =  INS_ASSETS_URL.'/app/css/instantio-style.min.css';
        }
        return $style;
    }

    // Checked ins minified js status
    public function ins_script_min_status_checked($script){
        $js_min = insopt('js-min');
        if(isset($js_min) && $js_min == true){
            $script =  INS_ASSETS_URL.'/app/js/instantio-script.min.js';
        }
        return $script;
    }

    // enqueue custom inline Css scripts
    public function enqueue_custom_css_scripts_pro(){
        $output = '';

        // ins-toggle-panel-tab
        $ins_toggle_panel_tab = insopt('ins-toggle-panel-tab');

        $output = '';

        // Billing Section
        // ins_bill_bg_padding_option
        $ins_bill_bg_padding_option = isset($ins_toggle_panel_tab['ins-bill-bg-padding_option']) && !empty($ins_toggle_panel_tab['ins-bill-bg-padding_option']) ? $ins_toggle_panel_tab['ins-bill-bg-padding_option'] : false;

        
        $ins_bill_bg_padding_top = isset($ins_toggle_panel_tab['ins-bill-bg-padding-top']) && !empty($ins_toggle_panel_tab['ins-bill-bg-padding-top']) ? $ins_toggle_panel_tab['ins-bill-bg-padding-top'] : '0';
        $ins_bill_bg_padding_right = isset($ins_toggle_panel_tab['ins-bill-bg-padding-right']) && !empty($ins_toggle_panel_tab['ins-bill-bg-padding-right']) ? $ins_toggle_panel_tab['ins-bill-bg-padding-right'] : '0';
        $ins_bill_bg_padding_bottom = isset($ins_toggle_panel_tab['ins-bill-bg-padding-bottom']) && !empty($ins_toggle_panel_tab['ins-bill-bg-padding-bottom']) ? $ins_toggle_panel_tab['ins-bill-bg-padding-bottom'] : '0';
        $ins_bill_bg_padding_left = isset($ins_toggle_panel_tab['ins-bill-bg-padding-left']) && !empty($ins_toggle_panel_tab['ins-bill-bg-padding-left']) ? $ins_toggle_panel_tab['ins-bill-bg-padding-left'] : '0'; 
         

        if($ins_bill_bg_padding_option == false){
            $ins_bill_bg_padding_top    = '';
            $ins_bill_bg_padding_right  = '';
            $ins_bill_bg_padding_bottom = '';
            $ins_bill_bg_padding_left   = '';
        }

        $ins_bill_bg = isset($ins_toggle_panel_tab['ins-bill-bg']) && !empty($ins_toggle_panel_tab['ins-bill-bg']) ? $ins_toggle_panel_tab['ins-bill-bg'] : 'transparent';

        $ins_bill_heading = isset($ins_toggle_panel_tab['ins-bill-heading']) && !empty($ins_toggle_panel_tab['ins-bill-heading']) ? $ins_toggle_panel_tab['ins-bill-heading'] : 'var(--ins_checkout_theme)';

        $ins_bill_label = isset($ins_toggle_panel_tab['ins-bill-label']) && !empty($ins_toggle_panel_tab['ins-bill-label']) ? $ins_toggle_panel_tab['ins-bill-label'] : '#665f5c';

        $ins_bill_input_bg = isset($ins_toggle_panel_tab['ins-bill-input-bg']) && !empty($ins_toggle_panel_tab['ins-bill-input-bg']) ? $ins_toggle_panel_tab['ins-bill-input-bg'] : '#fff5f0';

        $ins_bill_input_border = isset($ins_toggle_panel_tab['ins-bill-input-border']) && !empty($ins_toggle_panel_tab['ins-bill-input-border']) ? $ins_toggle_panel_tab['ins-bill-input-border'] : '';
        
        $ins_bill_input_text = isset($ins_toggle_panel_tab['ins-bill-input-text']) && !empty($ins_toggle_panel_tab['ins-bill-input-text']) ? $ins_toggle_panel_tab['ins-bill-input-text'] : '#43454b';
        
        $ins_bill_input_shadow = isset($ins_toggle_panel_tab['ins-bill-input-shadow']) && !empty($ins_toggle_panel_tab['ins-bill-input-shadow']) ? 'inset 0 1px 1px  ' .$ins_toggle_panel_tab['ins-bill-input-shadow'].' !important' : 'none';
        

        $output .= ' 
            .ins-cart-inner.shipping {
                background-color: '. $ins_bill_bg.' !important;
                padding-top: '. $ins_bill_bg_padding_top.'px !important;
                padding-left: '. $ins_bill_bg_padding_left.'px !important;
                padding-right: '. $ins_bill_bg_padding_right.'px !important;
                padding-bottom: '. $ins_bill_bg_padding_bottom.'px !important;
            }
            .ins-cart-inner.shipping h3, .ins-cart-inner.shipping h3 span {
                color: '.$ins_bill_heading.' !important;
            }
            .ins-cart-inner.shipping  label  {
                color: '.$ins_bill_label.' !important;
            }
            .ins-cart-inner.shipping input, .ins-cart-inner.shipping textarea, .ins-cart-inner.shipping select {
                background-color: '.$ins_bill_input_bg.' !important;
                border: 1px solid '.$ins_bill_input_border.' !important;
                color: '.$ins_bill_input_text.' !important;
                box-shadow: '.$ins_bill_input_shadow.';
            }
            .ins-cart-inner.shipping .woocommerce-billing-fields > div p textarea,
            .ins-cart-inner.shipping .woocommerce-billing-fields > div p select,
            .ins-cart-inner.shipping .woocommerce-billing-fields > div p input{
                border-color: '.$ins_bill_input_border.' !important;
            }
        '; 


        // Payment Section
        $ins_pay_item_bg = isset($ins_toggle_panel_tab['ins-pay-item-bg']) && !empty($ins_toggle_panel_tab['ins-pay-item-bg']) ? $ins_toggle_panel_tab['ins-pay-item-bg'] : 'transparent';

        $ins_pay_wrap_bg = isset($ins_toggle_panel_tab['ins_pay_wrap_bg']) && !empty($ins_toggle_panel_tab['ins_pay_wrap_bg']) ? $ins_toggle_panel_tab['ins_pay_wrap_bg'] : '#FCFCFC';

        $ins_pay_item_title = isset($ins_toggle_panel_tab['ins-pay-item-title']) && !empty($ins_toggle_panel_tab['ins-pay-item-title']) ? $ins_toggle_panel_tab['ins-pay-item-title'] : '#665f5c';

        $ins_pay_item_txt = isset($ins_toggle_panel_tab['ins-pay-item-txt']) && !empty($ins_toggle_panel_tab['ins-pay-item-txt']) ? $ins_toggle_panel_tab['ins-pay-item-txt'] : '';

        $ins_place_order_button_bg_regular = isset($ins_toggle_panel_tab['ins-place-order-button-bg']['regular']) && !empty($ins_toggle_panel_tab['ins-place-order-button-bg']['regular']) ? $ins_toggle_panel_tab['ins-place-order-button-bg']['regular'] : '';

        $ins_place_order_button_bg_hover = isset($ins_toggle_panel_tab['ins-place-order-button-bg']['hover']) && !empty($ins_toggle_panel_tab['ins-place-order-button-bg']['hover']) ? $ins_toggle_panel_tab['ins-place-order-button-bg']['hover'] : '';

        $ins_place_order_button_border_regular = isset($ins_toggle_panel_tab['ins-place-order-button-border']['regular']) && !empty($ins_toggle_panel_tab['ins-place-order-button-border']['regular']) ? $ins_toggle_panel_tab['ins-place-order-button-border']['regular'] : '';

        $ins_place_order_button_border_hover = isset($ins_toggle_panel_tab['ins-place-order-button-border']['hover']) && !empty($ins_toggle_panel_tab['ins-place-order-button-border']['hover']) ? $ins_toggle_panel_tab['ins-place-order-button-border']['hover'] : '';

        $ins_place_order_button_text_regular = isset($ins_toggle_panel_tab['ins-place-order-button-text']['regular']) && !empty($ins_toggle_panel_tab['ins-place-order-button-text']['regular']) ? $ins_toggle_panel_tab['ins-place-order-button-text']['regular'] : '';

        $ins_place_order_button_text_hover = isset($ins_toggle_panel_tab['ins-place-order-button-text']['hover']) && !empty($ins_toggle_panel_tab['ins-place-order-button-text']['hover']) ? $ins_toggle_panel_tab['ins-place-order-button-text']['hover'] : '';

        $output .= ' 
            .ins-cart-inner.payment {
                background-color: '.$ins_pay_item_bg.' !important;
            } 
            .ins-cart-inner.payment .ins-cart-content-wrap {
                background-color: '.$ins_pay_wrap_bg.';
            }
            .ins-cart-inner.payment .ins-cart-content-wrap p, .ins-cart-inner.payment .ins-cart-content-wrap span, .ins-cart-inner.payment .ins-cart-content-wrap label {
                color: '.$ins_pay_item_txt.' !important;
            }
            .ins-cart-inner.payment .ins-cart-content-wrap h3 {
                color: '.$ins_pay_item_title.' !important;
            }
            .ins-cart-inner.payment .ins-payment-wrap .ins-cart-content-wrap .ins-cart-summery h3{
                color: '.$ins_pay_item_title.' !important;
            }
            #place_order {
                background-color: '.$ins_place_order_button_bg_regular.' !important;
                color: '.$ins_place_order_button_text_regular.' !important;
                border-color: '.$ins_place_order_button_border_regular.' !important;
            }
            #place_order:hover {
                background-color: '.$ins_place_order_button_bg_hover.' !important;
                color: '.$ins_place_order_button_text_hover.' !important;
                border-color: '.$ins_place_order_button_border_hover.' !important;
            }
        '; 


        $mobile_cart_panel = !empty(insopt( 'mobile-cart-panel' )) ? insopt( 'mobile-cart-panel' ) : false;
        $dedicated_mobile = !empty(insopt( 'dedicated_mobile' )) ? insopt( 'dedicated_mobile' ) : false;

        if($mobile_cart_panel == true && $dedicated_mobile == true){
            $output .= ' 
                @media (max-width: 576px) { 
                    .ins-mobile-bar {
                        display: flex;
                        visibility: visible;
                    }
                }
            ';
        }

        wp_add_inline_style( 'ins-style-pro', $output );
    }

    // Enqueue Custom iinline js
    public function enqueue_custom_js_scripts_pro(){

        $output ='';

		wp_add_inline_script( 'ins-script-pro', $output );
    }

    
}

?>