<?php
// don't load directly
defined( 'ABSPATH' ) || exit;

require_once "InstantioProBase.php";

class InstantioPro {

    public $plugin_file=__FILE__;
    public $responseObj;
    public $licenseMessage;
    public $showMessage=false;
    public $slug="ins-license-activation";

    function __construct() {
    	update_option("InstantioPro_lic_Key", "11111111-2222-3333-4444-555555555555");
		update_option("InstantioPro_lic_email", "no@email.com");
        $licenseKey=get_option("InstantioPro_lic_Key","");
        $liceEmail=get_option( "InstantioPro_lic_email","");

        InstantioProBase::addOnDelete(function() {
           delete_option("InstantioPro_lic_Key");
        });

        add_filter( 'ins_checked_license_status', array($this, 'ins_checked_license_status'));

        if(InstantioProBase::CheckWPPlugin($licenseKey,$liceEmail,$this->licenseMessage,$this->responseObj,INS_PRO_PATH . 'wooinstant.php')) {
            add_action( 'admin_menu', [$this,'ActiveAdminMenu'],99999);
            add_action( 'admin_post_InstantioPro_el_deactivate_license', [ $this, 'action_deactivate_license' ] );

        } else {
			add_action('admin_post_InstantioPro_el_activate_license', [ $this, 'action_activate_license']);
            add_action( 'admin_menu', [$this,'InactiveMenu'],99999);

            /**
             * License Warning
             */
            function ins_license_warning () {
                $display_status = get_option( 'ins-license-dismiss' );
                if ($display_status) { ?>

                    <div id="ins-license-notice" class="notice notice-warning is-dismissible">
                        <p>
                            <strong>
                                <?php esc_attr_e( 'Please ', 'instantio' ); ?> <a href="<?php echo esc_url( admin_url('/admin.php?page=ins-license-activation') ); ?>">activate your license</a><?php esc_attr_e( ' key to enable getting future updates for Instantio Pro.', 'instantio' ); ?>
                            </strong>
                        </p>
                    </div>

                    <script>
                        jQuery(document).ready(function($) {
                            $(document).on('click', '#ins-license-notice .notice-dismiss', function( event ) {
                                jQuery('#ins-license-notice').css('display', 'none')
                                data = {
                                    action : 'disable_ins_license_notice',
                                };

                                $.post(ajaxurl, data, function (response) {
                                });
                            });
                        });
                    </script>

                <?php }
            }
            add_action( 'admin_notices', 'ins_license_warning' );

            function disable_ins_license_notice() {
                update_option( 'ins-license-dismiss', false );
                wp_die();
            }

            add_action( 'wp_ajax_disable_ins_license_notice', 'disable_ins_license_notice' );

            function set_ins_license_dismiss() {
                update_option( 'ins-license-dismiss', true );
            }

            register_activation_hook(  plugin_dir_path( __FILE__ ) . 'wooinstant.php', 'set_ins_license_dismiss' );

            if(!empty($licenseKey) && !empty($this->licenseMessage)){
               $this->showMessage=true;
            }

            update_option("InstantioPro_lic_Key","") || add_option("InstantioPro_lic_Key","");
        }
    }

    function ActiveAdminMenu() {
		add_submenu_page('wiopt', __( 'Instantio License Info', 'instantio' ), __( 'License Info', 'instantio' ), "activate_plugins",  $this->slug, [$this,"Activated"]);

		if (!is_plugin_active( 'instantio/instantio.php' )) {
			add_menu_page( __( 'Instantio License Info', 'instantio' ), __( 'Instantio', 'instantio' ), 'activate_plugins', $this->slug,  [$this,"Activated"], "dashicons-cart" );
		}

    }


    function ins_checked_license_status(){
        if(empty($this->responseObj) || $this->responseObj == NULL){
            return false;
        }
        return $this->responseObj;
    }

    function InactiveMenu() {
		add_submenu_page(  'wiopt', __( 'Instantio License Activation', 'instantio' ), __( 'License Activation', 'instantio' ), "activate_plugins",  $this->slug, [$this,"LicenseForm"] );

		if ( !is_plugin_active( 'instantio/instantio.php' )) {
			add_menu_page( __( 'wiopt', 'instantio' ), __( 'Instantio', 'instantio' ), 'activate_plugins', $this->slug,  [$this,"LicenseForm"], "dashicons-cart" );
		}
    }

    function action_activate_license() {
        check_admin_referer( 'el-license' );
        $licenseKey=!empty($_POST['el_license_key'])?$_POST['el_license_key']:"";
        $licenseEmail=!empty($_POST['el_license_email'])?$_POST['el_license_email']:"";
        update_option("InstantioPro_lic_Key",$licenseKey) || add_option("InstantioPro_lic_Key",$licenseKey);
        update_option("InstantioPro_lic_email",$licenseEmail) || add_option("InstantioPro_lic_email",$licenseEmail);
        update_option('_site_transient_update_plugins','');
        wp_safe_redirect(admin_url( 'admin.php?page='.$this->slug));
    }

    function action_deactivate_license() {
        check_admin_referer( 'el-license' );
        $message="";
        if(InstantioProBase::RemoveLicenseKey(INS_PRO_PATH . 'wooinstant.php',$message)){
            update_option("InstantioPro_lic_Key","") || add_option("InstantioPro_lic_Key","");
            update_option('_site_transient_update_plugins','');
        }
        wp_safe_redirect(admin_url( 'admin.php?page='.$this->slug));
    }


    // License info
    function Activated() { ?>
        <form class="ins_license_wrap" method="post" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>">
            <input type="hidden" name="action" value="InstantioPro_el_deactivate_license"/>

            <h3 class="el-license-title">
                <i class="fas fa-key"></i>
                <?php _e("License Info","instantio");?>
            </h3>

            <div class="el-license-container">

                <ul class="el-license-info">
                    <li>
                        <span class="el-license-info-title"><?php _e("Status","instantio");?></span> :
                        <?php if ( $this->responseObj->is_valid ) : ?>
                            <span class="el-license-valid"><?php _e("Valid","instantio");?></span>
                        <?php else : ?>
                            <span class="el-license-Invalid"><?php _e("Invalid","instantio");?></span>
                        <?php endif; ?>
                    </li>

                    <li>
                        <div>
                            <span class="el-license-info-title">
                                <?php _e("License Type","instantio");?>
                            </span>
                            : <?php echo $this->responseObj->license_title; ?>
                        </div>
                    </li>

                    <li>
                        <div>
                            <span class="el-license-info-title">
                                <?php _e("License Expired on","instantio");?>
                            </span> :
                            <?php echo $this->responseObj->expire_date;
                                if(!empty($this->responseObj->expire_renew_link)) {
                            ?>
                                <a target="_blank" class="el-blue-btn" href="<?php echo $this->responseObj->expire_renew_link; ?>">
                                    <?php _e("Renew","instantio");?>
                                </a>
                            <?php } ?>
                        </div>
                    </li>

                    <li>
                        <div>
                            <span class="el-license-info-title">
                                <?php _e("Support Expired on","instantio");?>
                            </span> :
                            <?php
                                echo $this->responseObj->support_end;
                                if(!empty($this->responseObj->support_renew_link)) { ?>
                                    <a target="_blank" class="el-blue-btn" href="<?php echo $this->responseObj->support_renew_link; ?>">
                                        <?php _e("Renew","instantio");?>
                                    </a>
                            <?php } ?>
                        </div>
                    </li>

                    <li>
                        <div>
                            <span class="el-license-info-title">
                                <?php _e("Your License Key","instantio");?> :
                            </span> :

                            <span class="el-license-key">
                                <?php echo esc_attr( substr($this->responseObj->license_key,0,9)."XXXXXXXX-XXXXXXXX".substr($this->responseObj->license_key,-9) ); ?>
                            </span>
                        </div>
                    </li>
                </ul>

                <div class="el-license-active-btn">
                    <?php wp_nonce_field( 'el-license' ); ?>
                    <?php submit_button(__( 'Deactivate', 'instantio' )); ?>
                </div>

            </div>
        </form>
    <?php }

    // License Form For Activation
    function LicenseForm() { ?>
        <form class="ins_license_wrap" method="post" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>">
            <input type="hidden" name="action" value="InstantioPro_el_activate_license"/>

            <h3 class="el-license-title">
                <i class="fas fa-key"></i>
                <?php _e("Instantio Pro Licensing","instantio");?>
            </h3>

            <div class="el-license-container">

                <?php if(!empty($this->showMessage) && !empty($this->licenseMessage)) { ?>
                    <div class="notice notice-error is-dismissible">
                        <p>
                            <?php echo _e($this->licenseMessage,"instantio"); ?>
                        </p>
                    </div>
                <?php } ?>

                <p style="font-size: 16px;">
                    <?php _e("If you don't have a license key, please ","instantio");?><a href="https://wpinstant.io/license-key/" target="_blank"><?php _e("click here","instantio");?></a><?php _e(" to request a license key.","instantio");?>
                </p>

                <p>
                    <?php _e("Enter your license key here, to activate the product, and get full feature updates and premium support.","instantio");?>
                </p>

                <div class="el-license-field">
                    <label for="el_license_key">
                        <?php _e("License code","instantio");?>
                    </label>
                    <input type="text" class="regular-text code" name="el_license_key" size="50" placeholder="xxxxxxxx-xxxxxxxx-xxxxxxxx-xxxxxxxx" required="required">
                </div>

                <div class="el-license-field">

                    <label for="el_license_key">
                        <?php _e("Email Address","instantio");?>
                    </label>

                    <?php
                        $purchaseEmail   = get_option( "InstantioPro_lic_email", get_bloginfo( 'admin_email' ));
                    ?>

                    <input type="text" class="regular-text code" name="el_license_email" size="50" value="<?php echo $purchaseEmail; ?>" placeholder="" required="required">

                </div>

                <div class="el-license-active-btn">
                    <?php wp_nonce_field( 'el-license' ); ?>
                    <?php submit_button(__( 'Activate', 'instantio' )); ?>
                </div>
            </div>
        </form>
    <?php }
}

new InstantioPro();

function is_tf_pro(){
    return false;
}

/**
* Licence Admin Get Option
*/
if ( ! function_exists( 'tfliopt' ) ) {
    function tfliopt( $option = '', $default = null ) {
        $options = get_option( 'tf_license_settings' );
        return ( isset( $options[ $option ] ) ) ? $options[ $option ] : $default;
    }
}

?>
